%% Prameters
display(' ');

% dataset = 'trevi';
% dataset = 'notredame';
dataset = 'halfdome';


% Path of data patches
image_path = ['PhotoTourismData\' dataset '\'];

% Output file path & name
output_path = ['data_' dataset '_jitter.mat']; 

FC = [32; 32; 6; 0]; % SIFT Frame Center

display(['Read files from ' image_path]);
display(['Write SIFT data to ' output_path]);
display(' ');


%% Read info file
fin = fopen([image_path 'info.txt']);
patch_info = fscanf(fin, '%d');
patch_info = patch_info(1:2:end); % ignore photo index
num_patches = length(patch_info);
display(['Number of patches : ' num2str(num_patches)]);
fclose(fin);


%% Read images
display('Read images.');
image_num = 0;
patch_num = 0;
Patch = struct('label', num2cell(patch_info), 'raw', zeros(1, 4096), 'sift', zeros(1, 128));

while true
	image_name = sprintf('patches%04d.bmp', image_num);
	try
		I = imread([image_path image_name]);
		
		for i = 1:16
			for j = 1:16
				if patch_num == num_patches
					throw(MException('Good', 'Read complete'));
				end
				patch = I((i - 1) * 64 + (1:64), (j - 1) * 64 + (1:64));
				patch_num = patch_num + 1;
				% [F, D] = vl_sift(single(patch), 'frames', FC, 'orientations');
				% Patch(patch_num).sift = D';
                jittered_patch = jitter_patch(patch);
                Patch(patch_num).sift = sift_of_image(jittered_patch)';
                if size(Patch(patch_num).sift, 1) ~= 1
                    display(['Patch #' num2str(patch_num) 'has more than one descriptor.']);
                end
                Patch(patch_num).raw = jittered_patch(1:end);
			end
		end
	catch ME
		break;
	end
	image_num = image_num + 1;

	if mod(image_num, 50) == 0
		display(['    ' num2str(image_num) ' images are done...']);
	end
end
display(' ');


%% Write raw & SIFT features
display('Write features.');
save(output_path, 'Patch');
display(' ');

