function pairs = pick_pairs(labels, num_pairs, type, l, u)
% ''labels'' is 1 x N matrix
% ''type'' is either True or False, True for matching pair, False for non-matching pair

N = length(labels);
pairs = zeros(num_pairs, 4);

for i = 1:num_pairs
    r1 = randi([1, N], 1, 1);
    indices = find((labels == labels(r1)) == type);
    r2 = indices(randi([1, length(indices)], 1, 1));
    
    if type
        pairs(i, :) = [r1 r2 1 l];
    else
        pairs(i, :) = [r1 r2 -1 u];
    end    
end
    

% num_random_pairs = num_pairs * 2;
% r = randi([1, N], num_random_pairs, 2);
% 
% idx_random_pairs = 1;
% for i = 1:num_pairs    
%     while true
%         idx_random_pairs = idx_random_pairs + 1;
%         if idx_random_pairs > num_random_pairs
%             idx_random_pairs = 1;
%             r = randi([1, N], num_random_pairs, 2);
%         end
%         if (labels(r(idx_random_pairs, 1)) == labels(r(idx_random_pairs, 2))) == type
%             pairs(i, 1) = r(idx_random_pairs, 1);
%             pairs(i, 2) = r(idx_random_pairs, 2);
%             break;
%         end
%     end
% end
